if(isFile("Add-Ons/System_ReturnToBlockland/server.cs"))
{
	if(!$RTB::RTBR_ServerControl_Hook) exec("Add-Ons/System_ReturnToBlockland/RTBR_ServerControl_Hook.cs");
	RTB_registerPref("Can players build?","Building Disabling Mod","$BuildingAllowed","bool","Script_DisableBuilding",1,0,0,"buildmessage");
	RTB_addInfoTip("You can disable building in server prefs.", "", "Building Disabling Mod");
	RTB_addInfoTip("You can take away someones building rights by typing /disablebuild [player name].", "", "Building Disabling Mod");
	RTB_addInfoTip("You can give back someones building rights by typing /enablebuild [player name].", "", "Building Disabling Mod");
}

function buildmessage(%old, %new)
{
	if($BuildingAllowed)
	{
	schedule(10, 0, "messageall", "", "\c3+ Building Disabling Mod: \c0Players can now build.");
	}
	if(!$BuildingAllowed)
	{
	schedule(10, 0, "messageall", "", "\c3+ Building Disabling Mod: \c0Players can no longer build.");
	}
}

package DisableBuilding
{
   function gameconnection::OnClientEnterGame(%this,%obj,%a,%b,%c,%d,%e)
	{
		%this.buildallow = 1;
		Parent::OnClientEnterGame(%this,%a,%b,%c,%d,%e);
	}
   function fxDTSbrick::Plant(%brick, %client, %obj)
	{
      %e = Parent::Plant(%brick);
         if(!%e)
         {
            %c = getbrickgroupfromobject(%brick).client;
            if(isObject(%c) && isObject(%c.player) && isObject(%c.player.tempbrick))
            {
               if($BuildingAllowed)
               {
               if(%c.buildallow == 1)
               {
                  Parent::Plant(%brick);
               }
               else
               {
                  commandtoclient(%c,'centerprint',"\c6You arn\'t allowed to build.",2);
                  %brick.schedule(0,"delete");
               }
               }
               else
               {
                  //commandtoclient(%c,'centerprint',"\c6Building is disabled.",2);
                  %brick.schedule(0,"delete");
               }
            }
         }
      }
      function servercmddisablebuild(%client, %target)
      {
         if(!%client.isAdmin)
         {
            return;
         }
         %target = findClientbyName(%target);
         %target.buildallow = 0;
         messageClient(%client,'',"\c3" @ %target.name @ "\c0 can no longer build.");
         messageClient(%target,'',"\c3You can no longer build");
      }
      function servercmdenablebuild(%client, %target)
      {
         if(!%client.isAdmin)
         {
            return;
         }
         %target = findClientbyName(%target);
         %target.buildallow = 1;
         messageClient(%client,'',"\c3" @ %target.name @ "\c0 can now build.");
         messageClient(%target,'',"\c3You can now build");
      }
};
activatepackage(DisableBuilding);